From e753a7be44c02d526b86ea85519608e35a80f49d Mon Sep 17 00:00:00 2001
From: Sergey Volkov <s.volkov@netris.ru>
Date: Thu, 11 Jan 2018 15:30:39 +0300
Subject: [PATCH 2/3] Android. Add HttpClient.cache property

---
 .../src/java/ti/modules/titanium/network/HTTPClientProxy.java        | 2 ++
 .../network/src/java/ti/modules/titanium/network/TiHTTPClient.java   | 3 ++-
 android/titanium/src/java/org/appcelerator/titanium/TiC.java         | 5 +++++
 apidoc/Titanium/Network/HTTPClient.yml                               | 4 ++--
 4 files changed, 11 insertions(+), 3 deletions(-)

diff --git a/android/modules/network/src/java/ti/modules/titanium/network/HTTPClientProxy.java b/android/modules/network/src/java/ti/modules/titanium/network/HTTPClientProxy.java
index aab9801..b8e91c6 100644
--- a/android/modules/network/src/java/ti/modules/titanium/network/HTTPClientProxy.java
+++ b/android/modules/network/src/java/ti/modules/titanium/network/HTTPClientProxy.java
@@ -23,6 +23,7 @@ import ti.modules.titanium.xml.DocumentProxy;
 import android.os.Build;
 
 @Kroll.proxy(creatableInModule=NetworkModule.class, propertyAccessors = {
+	TiC.PROPERTY_CACHE,
 	TiC.PROPERTY_FILE,
 	TiC.PROPERTY_ONSENDSTREAM,
 	TiC.PROPERTY_ONLOAD,
@@ -47,6 +48,7 @@ public class HTTPClientProxy extends KrollProxy
 	public HTTPClientProxy()
 	{
 		super();
+		defaultValues.put(TiC.PROPERTY_CACHE, false);
 		this.client = new TiHTTPClient(this);
 	}
 
diff --git a/android/modules/network/src/java/ti/modules/titanium/network/TiHTTPClient.java b/android/modules/network/src/java/ti/modules/titanium/network/TiHTTPClient.java
index 662f38b..dc306f7 100644
--- a/android/modules/network/src/java/ti/modules/titanium/network/TiHTTPClient.java
+++ b/android/modules/network/src/java/ti/modules/titanium/network/TiHTTPClient.java
@@ -1338,13 +1338,14 @@ public class TiHTTPClient
 				return;
 			}
 
+			client.setUseCaches(TiConvert.toBoolean(proxy.getProperty(TiC.PROPERTY_CACHE)));
 			client.setRequestMethod(method);
 			client.setDoInput(true);
 
 			if (isPostOrPutOrPatch) {
 				client.setDoOutput(true);
 			}
-			client.setUseCaches(false);
+
 			//Set Authorization value for Basic authentication
 			if (hasAuthentication) {
 				String domain = proxy.getDomain();
diff --git a/android/titanium/src/java/org/appcelerator/titanium/TiC.java b/android/titanium/src/java/org/appcelerator/titanium/TiC.java
index 6fd5c4d..79aa1c3 100644
--- a/android/titanium/src/java/org/appcelerator/titanium/TiC.java
+++ b/android/titanium/src/java/org/appcelerator/titanium/TiC.java
@@ -1088,6 +1088,11 @@ public class TiC
 	/**
 	 * @module.api
 	 */
+	public static final String PROPERTY_CACHE = "cache";
+
+	/**
+	 * @module.api
+	 */
 	public static final String PROPERTY_CACHE_MODE = "cacheMode";
 
 	/**
diff --git a/apidoc/Titanium/Network/HTTPClient.yml b/apidoc/Titanium/Network/HTTPClient.yml
index ecd886c..ebe513f 100644
--- a/apidoc/Titanium/Network/HTTPClient.yml
+++ b/apidoc/Titanium/Network/HTTPClient.yml
@@ -548,9 +548,9 @@ properties:
 
         This propery must be set before `open` is called.
     type: Boolean
-    since: "2.0.0"
+    since: {android: "8.0.0", iphone: "2.0.0", ipad: "2.0.0"}
     default: false
-    platforms: [iphone, ipad]
+    platforms: [android, iphone, ipad]
 
 examples:
   - title: Simple GET Request
-- 
2.7.4

